#include "stm32f10x.h"
#include "main.h"
#include "ir_in_out.h"

//¼ң
int IR_Data_Input(unsigned int KEY_GPIO_p)
{
	unsigned int t, i;
	unsigned int samples_min = 65535;
	unsigned int samples_correct = 0;
	unsigned int samples_quantity = 0;
	unsigned int Level_Time = INPUT_LEVEL_TIME_62ms;
	
	//򿪺յԴ
	GPIO_SetBits(GPIOB,GPIO_Pin_9);	
	//վ
	for(i=0; i<SAMPLE_COUNT; i++){samples[i] = 0;}
	//ȴ¼
	for(t=0; t<WAITING_TIM; t++)
	{
		if((t % (Level_Time/3)) == 0)		//ȴ¼״̬˸
		{
			GPIO_WriteBit(GPIOB, (GPIO_Pin_5 << model), (BitAction)(1 - GPIO_ReadOutputDataBit(GPIOB, (GPIO_Pin_5 << model))));
		}
		if(t > (WAITING_TIM-1)) {i = SAMPLE_COUNT;}		//ʱ
		if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_0) == 0)	//ݿʼ¼
		{
			TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
			TIM_Cmd(TIM2, ENABLE);
			t = WAITING_TIM;
			i = 0;
		}
		if(GPIO_ReadInputDataBit(GPIOA, KEY_GPIO_p) == 0)	//ٴΰл˳ȴлǿģʽ
		{
			for(int j=0;j<3000;j++)		//ж
			{
				delay_ms(10);
				if(j>300)				//
				{
					Level_Time = INPUT_LEVEL_TIME_750ms;	//¼ƽΪ750ms
					t = 0;									//ȴ¼ʱ¿ʼ
				}
				if(GPIO_ReadInputDataBit(GPIOA, KEY_GPIO_p) == 1)
				{
					if(j<=300)				//̰
					{
						t = WAITING_TIM;	//˳ȴ
						i = SAMPLE_COUNT;	//˳¼״̬
					}
					j = 3000;			//˳жϳ
				}
				if((j % (Level_Time/2300)) == 0)	//¼״̬˸
				{
					GPIO_WriteBit(GPIOB, (GPIO_Pin_5 << model), (BitAction)(1 - GPIO_ReadOutputDataBit(GPIOB, (GPIO_Pin_5 << model))));
				}
			}
		}
	}
	//ʼ¼
	while (i<SAMPLE_COUNT)
	{
		for(t=0; t<Level_Time; t++)	//¼͵ƽ
		{
			if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_0) == 1)
			{
				samples[i] = TIM_GetCounter(TIM2);
				t = Level_Time;
				TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
				TIM_Cmd(TIM2, ENABLE);
			}
		}
		i++;
		for(t=0; t<Level_Time; t++)	//¼ߵƽ
		{
			if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_0) == 0)
			{
				samples[i] = TIM_GetCounter(TIM2);
				t = Level_Time;
				TIM_Cmd(TIM2, ENABLE);
				TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
			}
		}
		if(samples[i] == 0){i = SAMPLE_COUNT;}	//¼Ϊʱ˳
		i++;
	}
	//رպյԴ
	GPIO_ResetBits(GPIOB,GPIO_Pin_9);
	//رնʱ
	TIM_Cmd(TIM2, DISABLE);
	//Сֵ
	for(i=0; i<SAMPLE_COUNT; i++)
	{
		if(samples[i] < samples_min){samples_min = samples[i];}
		if((i+1) < SAMPLE_COUNT && samples[i+1] == 0){i = SAMPLE_COUNT;}
	}
	//ź
	for(i=0; i<SAMPLE_COUNT; i++)
	{
		if(samples[i] < (samples_min*1.2))
		{
			if(samples[i] > samples_correct){samples_correct = samples[i];}
		}
		if((i+1) < SAMPLE_COUNT && samples[i+1] == 0){i = SAMPLE_COUNT;}
	}
	samples_correct = (samples_correct - samples_min) / 2;
	for(i=0; i<SAMPLE_COUNT; i++)
	{
		if((i % 2) == 0){samples[i] -= samples_correct;}
		else{samples[i] += samples_correct;}
		if((i+1) < SAMPLE_COUNT && samples[i+1] == 0){i = SAMPLE_COUNT;}
	}
	//ʵ¼
	for(i=0; i<SAMPLE_COUNT; i++)
	{
		if(samples[i] != 0) {samples_quantity ++;}
	}
	//쳣ж
	if(samples_min == 0){return 50;}		//ȴʱ
	else if(samples_quantity < 20) {return 0;}	//¼
	else if(samples_min < 72){return 0;}	//¼źŲԣеС470usģ
	else{return 100;}
}

//ź
void IR_Output(unsigned int KEY_Data_Address)
{
	unsigned int i = 0;
	unsigned int Before_TIM = 0;
	unsigned int Today_TIM;
	unsigned short TIM_data;
	
	GPIO_SetBits(GPIOB, (GPIO_Pin_5 << model));		//ָʾǰ豸
	while (i<SAMPLE_COUNT)
	{
		TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
		TIM_Cmd(TIM2, ENABLE);
		GPIO_SetBits(GPIOB,GPIO_Pin_1);		//ߵƽ
		TIM_data = *(uint16_t *)(KEY_Data_Address+i*2);		//ȡӦ
		if(TIM_data>64000 || TIM_data == 0){TIM_data = 300;}
		while (TIM_GetCounter(TIM2)<TIM_data)
		{
			Today_TIM = TIM_GetCounter(TIM2);
			if((Today_TIM % 2) == 0 && Today_TIM != Before_TIM && Today_TIM != 0)	//38Kز,8MHz/53/4=38KHz	4/2=250%ռձȣ
			{
				Before_TIM = Today_TIM;
				GPIO_WriteBit(GPIOB, GPIO_Pin_1, (BitAction)(1 - GPIO_ReadOutputDataBit(GPIOB, GPIO_Pin_1)));
			}
		}
		i++;
		TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
		TIM_Cmd(TIM2, ENABLE);
		GPIO_ResetBits(GPIOB,GPIO_Pin_1);		//͵ƽ
		TIM_data = *(uint16_t *)(KEY_Data_Address+i*2);
		if(TIM_data>64000 || TIM_data == 0){TIM_data = 1;}
		while (TIM_GetCounter(TIM2)<TIM_data);
		i++;
		TIM_data = *(uint16_t *)(KEY_Data_Address+i*2);			//ȡӦ
		if(TIM_data == 0 || TIM_data == 65535) {i = SAMPLE_COUNT;}		//ݻʱֹͣ
	}
	TIM_Cmd(TIM2, DISABLE);		//رնʱ
	GPIO_ResetBits(GPIOB,(GPIO_Pin_5 << model));	//رָʾ
}

