#include "stm32f10x.h"
#include "main.h"
#include "store_data_in_flash.h"

// 洢ݵ Flash 
void StoreDataInFlash(int shifting) {
	 unsigned int new_address = FLASH_START_ADDRESS + (shifting * 1024);
    //  Flash
    FLASH_Unlock();
    
    // Ŀ Flash 
    FLASH_ErasePage(new_address);
    
    // д
    for (int i = 0; i < SAMPLE_COUNT; i++) {
        FLASH_ProgramHalfWord(new_address + i * 2, samples[i]);
    }
    
    //  Flash
    FLASH_Lock();
}
